#ifndef __CAPABILITIES_H
#define __CAPABILITIES_H

#define CAP_TS		0x00000001 /* timestamps */
#define CAP_CID		0x00000002 /* command IDs */
#define CAP_UID		0x00000004 /* server/user IDs */
#define CAP_BURSTTOPIC	0x00000008 /* send TOPICs on bursts */
#define CAP_EOB		0x00000010 /* End of Burst */

#define CAP_NJOIN      	0x00000100 /* NJOIN command */

#define CAP_ALL (CAP_TS | CAP_CID | CAP_UID | CAP_BURSTTOPIC | CAP_NJOIN)

unsigned int version_get_caps(const char *version);

#endif
