#ifndef __COMMAND_REPLIES_H
#define __COMMAND_REPLIES_H

void command_reply_whois(SendOptions *sopts, Server *server,
			 const char *nicks, int allow_uids);
void command_reply_whowas(SendOptions *sopts, Server *server,
			  const char *nicks, const char *countstr);

void command_reply_version(SendOptions *sopts, Server *server);
void command_reply_motd(SendOptions *sopts, Server *server);
void command_reply_lusers(SendOptions *sopts, Server *server, const char *mask);
void command_reply_links(SendOptions *sopts, Server *server, const char *mask);

void command_reply_names(Client *client, Channel *channel);

#endif
