#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>

#include "lib.h"
#include "dynarray.h"
#include "hash.h"
#include "tree.h"

typedef struct _IrcNetwork IrcNetwork;
typedef struct _Server Server;
typedef struct _ServerConn ServerConn;
typedef struct _Client Client;
typedef struct _Channel Channel;
typedef struct _Nick Nick;

typedef struct _IAuth IAuth;

#include "client.h"
#include "server.h"
#include "irc-network.h"
#include "numerics.h"
#include "log.h"
#include "capabilities.h"

#include "irc-limits.h"
#include "irc-strings.h"
#include "match.h"

#include "settings.h"
