#include "common.h"

#include "server.h"
#include "iauth-connection.h"

void server_log(Server *server, const char *msg, ...)
{
	va_list va;

	va_start(va, msg);
	fprintf(stderr, "%s: ", server->name);
	vfprintf(stderr, msg, va);
        fputc('\n', stderr);
        va_end(va);
}

void iauth_log(IAuth *iauth, const char *msg, ...)
{
	va_list va;

	va_start(va, msg);
	fprintf(stderr, "iauth(%d): ", iauth->ports[0]);
	vfprintf(stderr, msg, va);
        fputc('\n', stderr);
        va_end(va);
}
