#include "common.h"
#include "server-commands.h"

#ifdef USE_NUMERICS_ARRAY

static const char *numerics[] = {
/* 000 */	NULL,
/* 001 */	s_RPL_WELCOME,
/* 002 */	s_RPL_YOURHOST,
/* 003 */	s_RPL_CREATED,
/* 004 */	s_RPL_MYINFO,
/* 005 */	NULL,
/* 006 */	NULL,
/* 007 */	NULL,
/* 008 */	NULL,
/* 009 */	NULL,
/* 010 */	s_RPL_BOUNCE,
/* 011 */	NULL,
/* 012 */	NULL,
/* 013 */	NULL,
/* 014 */	NULL,
/* 015 */	s_RPL_MAP,
/* 016 */	NULL,
/* 017 */	s_RPL_MAPEND,
/* 018 */	NULL,
/* 019 */	NULL,
/* 020 */	NULL,
/* 021 */	NULL,
/* 022 */	NULL,
/* 023 */	NULL,
/* 024 */	NULL,
/* 025 */	NULL,
/* 026 */	NULL,
/* 027 */	NULL,
/* 028 */	NULL,
/* 029 */	NULL,
/* 030 */	NULL,
/* 031 */	NULL,
/* 032 */	NULL,
/* 033 */	NULL,
/* 034 */	NULL,
/* 035 */	NULL,
/* 036 */	NULL,
/* 037 */	NULL,
/* 038 */	NULL,
/* 039 */	NULL,
/* 040 */	NULL,
/* 041 */	NULL,
/* 042 */	s_RPL_YOURID,
/* 043 */	NULL,
/* 044 */	NULL,
/* 045 */	NULL,
/* 046 */	NULL,
/* 047 */	NULL,
/* 048 */	NULL,
/* 049 */	NULL,
/* 050 */	NULL,
/* 051 */	NULL,
/* 052 */	NULL,
/* 053 */	NULL,
/* 054 */	NULL,
/* 055 */	NULL,
/* 056 */	NULL,
/* 057 */	NULL,
/* 058 */	NULL,
/* 059 */	NULL,
/* 060 */	NULL,
/* 061 */	NULL,
/* 062 */	NULL,
/* 063 */	NULL,
/* 064 */	NULL,
/* 065 */	NULL,
/* 066 */	NULL,
/* 067 */	NULL,
/* 068 */	NULL,
/* 069 */	NULL,
/* 070 */	NULL,
/* 071 */	NULL,
/* 072 */	NULL,
/* 073 */	NULL,
/* 074 */	NULL,
/* 075 */	NULL,
/* 076 */	NULL,
/* 077 */	NULL,
/* 078 */	NULL,
/* 079 */	NULL,
/* 080 */	NULL,
/* 081 */	NULL,
/* 082 */	NULL,
/* 083 */	NULL,
/* 084 */	NULL,
/* 085 */	NULL,
/* 086 */	NULL,
/* 087 */	NULL,
/* 088 */	NULL,
/* 089 */	NULL,
/* 090 */	NULL,
/* 091 */	NULL,
/* 092 */	NULL,
/* 093 */	NULL,
/* 094 */	NULL,
/* 095 */	NULL,
/* 096 */	NULL,
/* 097 */	NULL,
/* 098 */	NULL,
/* 099 */	NULL,
/* 100 */	NULL,
/* 101 */	NULL,
/* 102 */	NULL,
/* 103 */	NULL,
/* 104 */	NULL,
/* 105 */	NULL,
/* 106 */	NULL,
/* 107 */	NULL,
/* 108 */	NULL,
/* 109 */	NULL,
/* 110 */	NULL,
/* 111 */	NULL,
/* 112 */	NULL,
/* 113 */	NULL,
/* 114 */	NULL,
/* 115 */	NULL,
/* 116 */	NULL,
/* 117 */	NULL,
/* 118 */	NULL,
/* 119 */	NULL,
/* 120 */	NULL,
/* 121 */	NULL,
/* 122 */	NULL,
/* 123 */	NULL,
/* 124 */	NULL,
/* 125 */	NULL,
/* 126 */	NULL,
/* 127 */	NULL,
/* 128 */	NULL,
/* 129 */	NULL,
/* 130 */	NULL,
/* 131 */	NULL,
/* 132 */	NULL,
/* 133 */	NULL,
/* 134 */	NULL,
/* 135 */	NULL,
/* 136 */	NULL,
/* 137 */	NULL,
/* 138 */	NULL,
/* 139 */	NULL,
/* 140 */	NULL,
/* 141 */	NULL,
/* 142 */	NULL,
/* 143 */	NULL,
/* 144 */	NULL,
/* 145 */	NULL,
/* 146 */	NULL,
/* 147 */	NULL,
/* 148 */	NULL,
/* 149 */	NULL,
/* 150 */	NULL,
/* 151 */	NULL,
/* 152 */	NULL,
/* 153 */	NULL,
/* 154 */	NULL,
/* 155 */	NULL,
/* 156 */	NULL,
/* 157 */	NULL,
/* 158 */	NULL,
/* 159 */	NULL,
/* 160 */	NULL,
/* 161 */	NULL,
/* 162 */	NULL,
/* 163 */	NULL,
/* 164 */	NULL,
/* 165 */	NULL,
/* 166 */	NULL,
/* 167 */	NULL,
/* 168 */	NULL,
/* 169 */	NULL,
/* 170 */	NULL,
/* 171 */	NULL,
/* 172 */	NULL,
/* 173 */	NULL,
/* 174 */	NULL,
/* 175 */	NULL,
/* 176 */	NULL,
/* 177 */	NULL,
/* 178 */	NULL,
/* 179 */	NULL,
/* 180 */	NULL,
/* 181 */	NULL,
/* 182 */	NULL,
/* 183 */	NULL,
/* 184 */	NULL,
/* 185 */	NULL,
/* 186 */	NULL,
/* 187 */	NULL,
/* 188 */	NULL,
/* 189 */	NULL,
/* 190 */	NULL,
/* 191 */	NULL,
/* 192 */	NULL,
/* 193 */	NULL,
/* 194 */	NULL,
/* 195 */	NULL,
/* 196 */	NULL,
/* 197 */	NULL,
/* 198 */	NULL,
/* 199 */	NULL,
/* 200 */	s_RPL_TRACELINK,
/* 201 */	s_RPL_TRACECONNECTING,
/* 202 */	s_RPL_TRACEHANDSHAKE,
/* 203 */	s_RPL_TRACEUNKNOWN,
/* 204 */	s_RPL_TRACEOPERATOR,
/* 205 */	s_RPL_TRACEUSER,
/* 206 */	s_RPL_TRACESERVER,
/* 207 */	s_RPL_TRACESERVICE,
/* 208 */	s_RPL_TRACENEWTYPE,
/* 209 */	s_RPL_TRACECLASS,
/* 210 */	NULL,
/* 211 */	s_RPL_STATSLINKINFO,
/* 212 */	s_RPL_STATSCOMMANDS,
/* 213 */	s_RPL_STATSCLINE,
/* 214 */	s_RPL_STATSNLINE,
/* 215 */	s_RPL_STATSILINE,
/* 216 */	s_RPL_STATSKLINE,
/* 217 */	s_RPL_STATSQLINE,
/* 218 */	s_RPL_STATSYLINE,
/* 219 */	s_RPL_ENDOFSTATS,
/* 220 */	NULL,
/* 221 */	s_RPL_UMODEIS,
/* 222 */	NULL,
/* 223 */	NULL,
/* 224 */	NULL,
/* 225 */	NULL,
/* 226 */	NULL,
/* 227 */	NULL,
/* 228 */	NULL,
/* 229 */	NULL,
/* 230 */	NULL,
/* 231 */	s_RPL_SERVICEINFO,
/* 232 */	s_RPL_ENDOFSERVICES,
/* 233 */	s_RPL_SERVICE,
/* 234 */	s_RPL_SERVLIST,
/* 235 */	s_RPL_SERVLISTEND,
/* 236 */	NULL,
/* 237 */	NULL,
/* 238 */	NULL,
/* 239 */	s_RPL_STATSIAUTH,
/* 240 */	s_RPL_STATSVLINE,
/* 241 */	s_RPL_STATSLLINE,
/* 242 */	s_RPL_STATSUPTIME,
/* 243 */	s_RPL_STATSOLINE,
/* 244 */	s_RPL_STATSHLINE,
/* 245 */	s_RPL_STATSSLINE,
/* 246 */	s_RPL_STATSPING,
/* 247 */	s_RPL_STATSBLINE,
/* 248 */	s_RPL_STATSDEFINE,
/* 249 */	s_RPL_STATSDEBUG,
/* 250 */	s_RPL_STATSDLINE,
/* 251 */	s_RPL_LUSERCLIENT,
/* 252 */	s_RPL_LUSEROP,
/* 253 */	s_RPL_LUSERUNKNOWN,
/* 254 */	s_RPL_LUSERCHANNELS,
/* 255 */	s_RPL_LUSERME,
/* 256 */	s_RPL_ADMINME,
/* 257 */	s_RPL_ADMINLOC1,
/* 258 */	s_RPL_ADMINLOC2,
/* 259 */	s_RPL_ADMINEMAIL,
/* 260 */	NULL,
/* 261 */	s_RPL_TRACELOG,
/* 262 */	s_RPL_TRACEEND,
/* 263 */	s_RPL_TRYAGAIN,
/* 264 */	NULL,
/* 265 */	NULL,
/* 266 */	NULL,
/* 267 */	NULL,
/* 268 */	NULL,
/* 269 */	NULL,
/* 270 */	NULL,
/* 271 */	NULL,
/* 272 */	NULL,
/* 273 */	NULL,
/* 274 */	NULL,
/* 275 */	NULL,
/* 276 */	NULL,
/* 277 */	NULL,
/* 278 */	NULL,
/* 279 */	NULL,
/* 280 */	NULL,
/* 281 */	NULL,
/* 282 */	NULL,
/* 283 */	NULL,
/* 284 */	NULL,
/* 285 */	NULL,
/* 286 */	NULL,
/* 287 */	NULL,
/* 288 */	NULL,
/* 289 */	NULL,
/* 290 */	NULL,
/* 291 */	NULL,
/* 292 */	NULL,
/* 293 */	NULL,
/* 294 */	NULL,
/* 295 */	NULL,
/* 296 */	NULL,
/* 297 */	NULL,
/* 298 */	NULL,
/* 299 */	NULL,
/* 300 */	s_RPL_NONE,
/* 301 */	s_RPL_AWAY,
/* 302 */	s_RPL_USERHOST,
/* 303 */	s_RPL_ISON,
/* 304 */	s_RPL_TEXT,
/* 305 */	s_RPL_UNAWAY,
/* 306 */	s_RPL_NOWAWAY,
/* 307 */	NULL,
/* 308 */	NULL,
/* 309 */	NULL,
/* 310 */	NULL,
/* 311 */	s_RPL_WHOISUSER,
/* 312 */	s_RPL_WHOISSERVER,
/* 313 */	s_RPL_WHOISOPERATOR,
/* 314 */	s_RPL_WHOWASUSER,
/* 315 */	s_RPL_ENDOFWHO,
/* 316 */	s_RPL_WHOISCHANOP,
/* 317 */	s_RPL_WHOISIDLE,
/* 318 */	s_RPL_ENDOFWHOIS,
/* 319 */	s_RPL_WHOISCHANNELS,
/* 320 */	NULL,
/* 321 */	s_RPL_LISTSTART,
/* 322 */	s_RPL_LIST,
/* 323 */	s_RPL_LISTEND,
/* 324 */	s_RPL_CHANNELMODEIS,
/* 325 */	s_RPL_UNIQOPIS,
/* 326 */	NULL,
/* 327 */	NULL,
/* 328 */	NULL,
/* 329 */	NULL,
/* 330 */	NULL,
/* 331 */	s_RPL_NOTOPIC,
/* 332 */	s_RPL_TOPIC,
/* 333 */	NULL,
/* 334 */	NULL,
/* 335 */	NULL,
/* 336 */	NULL,
/* 337 */	NULL,
/* 338 */	NULL,
/* 339 */	NULL,
/* 340 */	NULL,
/* 341 */	s_RPL_INVITING,
/* 342 */	s_RPL_SUMMONING,
/* 343 */	NULL,
/* 344 */	NULL,
/* 345 */	NULL,
/* 346 */	s_RPL_INVITELIST,
/* 347 */	s_RPL_ENDOFINVITELIST,
/* 348 */	s_RPL_EXCEPTLIST,
/* 349 */	s_RPL_ENDOFEXCEPTLIST,
/* 350 */	NULL,
/* 351 */	s_RPL_VERSION,
/* 352 */	s_RPL_WHOREPLY,
/* 353 */	s_RPL_NAMREPLY,
/* 354 */	NULL,
/* 355 */	NULL,
/* 356 */	NULL,
/* 357 */	NULL,
/* 358 */	NULL,
/* 359 */	NULL,
/* 360 */	NULL,
/* 361 */	s_RPL_KILLDONE,
/* 362 */	s_RPL_CLOSING,
/* 363 */	s_RPL_CLOSEEND,
/* 364 */	s_RPL_LINKS,
/* 365 */	s_RPL_ENDOFLINKS,
/* 366 */	s_RPL_ENDOFNAMES,
/* 367 */	s_RPL_BANLIST,
/* 368 */	s_RPL_ENDOFBANLIST,
/* 369 */	s_RPL_ENDOFWHOWAS,
/* 370 */	NULL,
/* 371 */	s_RPL_INFO,
/* 372 */	s_RPL_MOTD,
/* 373 */	s_RPL_INFOSTART,
/* 374 */	s_RPL_ENDOFINFO,
/* 375 */	s_RPL_MOTDSTART,
/* 376 */	s_RPL_ENDOFMOTD,
/* 377 */	NULL,
/* 378 */	NULL,
/* 379 */	NULL,
/* 380 */	NULL,
/* 381 */	s_RPL_YOUREOPER,
/* 382 */	s_RPL_REHASHING,
/* 383 */	s_RPL_YOURESERVICE,
/* 384 */	s_RPL_MYPORTIS,
/* 385 */	s_RPL_NOTOPERANYMORE,
/* 386 */	NULL,
/* 387 */	NULL,
/* 388 */	NULL,
/* 389 */	NULL,
/* 390 */	NULL,
#ifdef ENABLE_USERS
/* 391 */	s_RPL_TIME,
/* 392 */	s_RPL_USERSSTART,
/* 393 */	s_RPL_USERS,
/* 394 */	s_RPL_ENDOFUSERS,
/* 395 */	s_RPL_NOUSERS,
#else
/* 391 */	NULL,
/* 392 */	NULL,
/* 393 */	NULL,
/* 394 */	NULL,
/* 395 */	NULL,
#endif
/* 396 */	NULL,
/* 397 */	NULL,
/* 398 */	NULL,
/* 399 */	NULL,
/* 400 */	NULL,
/* 401 */	s_ERR_NOSUCHNICK,
/* 402 */	s_ERR_NOSUCHSERVER,
/* 403 */	s_ERR_NOSUCHCHANNEL,
/* 404 */	s_ERR_CANNOTSENDTOCHAN,
/* 405 */	s_ERR_TOOMANYCHANNELS,
/* 406 */	s_ERR_WASNOSUCHNICK,
/* 407 */	s_ERR_TOOMANYTARGETS,
/* 408 */	s_ERR_NOSUCHSERVICE,
/* 409 */	s_ERR_NOORIGIN,
/* 410 */	NULL,
/* 411 */	s_ERR_NORECIPIENT,
/* 412 */	s_ERR_NOTEXTTOSEND,
/* 413 */	s_ERR_NOTOPLEVEL,
/* 414 */	s_ERR_WILDTOPLEVEL,
/* 415 */	s_ERR_BADMASK,
/* 416 */	s_ERR_TOOMANYMATCHES,
/* 417 */	NULL,
/* 418 */	NULL,
/* 419 */	NULL,
/* 420 */	NULL,
/* 421 */	s_ERR_UNKNOWNCOMMAND,
/* 422 */	s_ERR_NOMOTD,
/* 423 */	s_ERR_NOADMININFO,
/* 424 */	s_ERR_FILEERROR,
/* 425 */	NULL,
/* 426 */	NULL,
/* 427 */	NULL,
/* 428 */	NULL,
/* 429 */	NULL,
/* 430 */	NULL,
/* 431 */	s_ERR_NONICKNAMEGIVEN,
/* 432 */	s_ERR_ERRONEOUSNICKNAME,
/* 433 */	s_ERR_NICKNAMEINUSE,
/* 434 */	s_ERR_SERVICENAMEINUSE,
/* 435 */	s_ERR_SERVICECONFUSED,
/* 436 */	s_ERR_NICKCOLLISION,
/* 437 */	s_ERR_UNAVAILRESOURCE,
/* 438 */	NULL,
/* 439 */	NULL,
/* 440 */	NULL,
/* 441 */	s_ERR_USERNOTINCHANNEL,
/* 442 */	s_ERR_NOTONCHANNEL,
/* 443 */	s_ERR_USERONCHANNEL,
/* 444 */	s_ERR_NOLOGIN,
#ifndef ENABLE_SUMMON
/* 445 */	s_ERR_SUMMONDISABLED,
#else
/* 445 */	NULL,
#endif
#ifndef ENABLE_USERS
/* 446 */	s_ERR_USERSDISABLED,
#else
/* 446 */	NULL,
#endif
/* 447 */	NULL,
/* 448 */	NULL,
/* 449 */	NULL,
/* 450 */	NULL,
/* 451 */	s_ERR_NOTREGISTERED,
/* 452 */	NULL,
/* 453 */	NULL,
/* 454 */	NULL,
/* 455 */	NULL,
/* 456 */	NULL,
/* 457 */	NULL,
/* 458 */	NULL,
/* 459 */	NULL,
/* 460 */	NULL,
/* 461 */	s_ERR_NEEDMOREPARAMS,
/* 462 */	s_ERR_ALREADYREGISTRED,
/* 463 */	s_ERR_NOPERMFORHOST,
/* 464 */	s_ERR_PASSWDMISMATCH,
/* 465 */	s_ERR_YOUREBANNEDCREEP,
/* 466 */	s_ERR_YOUWILLBEBANNED,
/* 467 */	s_ERR_KEYSET,
/* 468 */	NULL,
/* 469 */	NULL,
/* 470 */	NULL,
/* 471 */	s_ERR_CHANNELISFULL,
/* 472 */	s_ERR_UNKNOWNMODE,
/* 473 */	s_ERR_INVITEONLYCHAN,
/* 474 */	s_ERR_BANNEDFROMCHAN,
/* 475 */	s_ERR_BADCHANNELKEY,
/* 476 */	s_ERR_BADCHANMASK,
/* 477 */	s_ERR_NOCHANMODES,
/* 478 */	s_ERR_BANLISTFULL,
/* 479 */	NULL,
/* 480 */	NULL,
/* 481 */	s_ERR_NOPRIVILEGES,
/* 482 */	s_ERR_CHANOPRIVSNEEDED,
/* 483 */	s_ERR_CANTKILLSERVER,
/* 484 */	s_ERR_RESTRICTED,
/* 485 */	s_ERR_UNIQOPRIVSNEEDED,
/* 486 */	NULL,
/* 487 */	NULL,
/* 488 */	NULL,
/* 489 */	NULL,
/* 490 */	NULL,
/* 491 */	s_ERR_NOOPERHOST,
/* 492 */	s_ERR_NOSERVICEHOST,
/* 493 */	NULL,
/* 494 */	NULL,
/* 495 */	NULL,
/* 496 */	NULL,
/* 497 */	NULL,
/* 498 */	NULL,
/* 499 */	NULL,
/* 500 */	NULL,
/* 501 */	s_ERR_UMODEUNKNOWNFLAG,
/* 502 */	s_ERR_USERSDONTMATCH
};
#define MAX_NUMERICS 502

void client_send_numeric(Client *client, int num, ...)
{
	va_list va;
        const char *format;

	va_start(va, num);

	format = num >= 1 && num <= MAX_NUMERICS ? numerics[num] : NULL;
	client_send(client, NULL,
		    t_strdup_printf("%03d %s %s", num, client->nick.nick,
				    format == NULL ? ":" :
				    t_strdup_vprintf(format+7, va)));

	va_end(va);
}

void send_numeric_reply(CommandOrigin *origin, int num, ...)
{
	va_list va;
        const char *format, *data;

	va_start(va, num);

	format = num >= 1 && num <= MAX_NUMERICS ? numerics[num] : NULL;
	data = t_strdup_printf("%03d %s %s", num, ORIGIN_GET_OUTPUTID(origin),
			       format == NULL ? ":" :
			       t_strdup_vprintf(format+7, va));
	send_command_reply(origin, data);

	va_end(va);
}

void send_numeric_to(SendOptions *sopts, const char *target, int num, ...)
{
	va_list va;
        const char *format;

	va_start(va, num);

	format = num >= 1 && num <= MAX_NUMERICS ? numerics[num] : NULL;

	send_to(sopts, t_strdup_printf("%03d %s %s", num, target,
				       format == NULL ? ":" :
				       t_strdup_vprintf(format+7, va)));

	va_end(va);
}

#endif
