#ifndef __IRC_NETWORK_H
#define __IRC_NETWORK_H

struct _IrcNetwork {
	char *name;
	char *address;
	char *channel;

	IPADDR ip;
	int port;

	IPADDR my_ip;
	int my_port;
};

IrcNetwork *irc_network_create(const char *name, const char *address,
			       const char *channel,
			       IPADDR *ip, int port,
			       IPADDR *my_ip, int my_port);
void irc_network_destroy(IrcNetwork *network);

#endif
