#ifndef __IRC_H
#define __IRC_H

/* Parse prefix part of the given line. Returns the rest of the line. */
char *irc_parse_prefix(char *line, char **prefix, int *timestamp,
		       const char **id);

/* Split given line to command and arguments, the command is returned.
   Size of args must be at least COMMAND_MAX_ARGS+1 long. */
const char *irc_parse_command(char *line, int *argc, const char *args[]);

#endif
