#include "common.h"
#include "version.h"

unsigned int version_get_caps(const char *version)
{
	/* FIXME: use flags or something :) check how hybrid does it */
	if (strncmp(version, "0212", 4) == 0)
		return CAP_ALL;

        /* IRCNet ircd 2.11 / 2.11 beta */
	if (strncmp(version, "0211", 4) == 0 ||
	    strncmp(version, "021099", 6) == 0)
                return CAP_UID | CAP_NJOIN;

        /* 2.10 ircd */
	if (strncmp(version, "0210", 4) == 0)
		return CAP_NJOIN;

        return 0;
}
