#ifndef __SERVER_H
#define __SERVER_H

struct _Server {
	Client *client;

	int handle; /* socket handle */
        IO io;

	TBuffer *inbuf, *outbuf;
};

Server *server_create(Client *client);
void server_destroy(Server *server);

void server_send(Server *server, const char *data);

void servers_init(void);
void servers_deinit(void);

#endif
